"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("util");
const puppeteer_1 = __importDefault(require("puppeteer"));
const options_1 = require("./options");
class HeadlessEval {
    constructor(opts) {
        this.opts = options_1.optsWithDefaults(opts);
        this.browserPromise = puppeteer_1.default.launch();
    }
    async evalSnippet(url, snippet) {
        const browser = await this.browserPromise;
        const page = await browser.newPage();
        try {
            return await this.doEvalSnippetInPage(page, url, snippet);
        }
        finally {
            await page.close();
        }
    }
    async close() {
        const browser = await this.browserPromise;
        return browser.close();
    }
    async doEvalSnippetInPage(page, url, snippet) {
        await page.goto(url, {
            waitUntil: "networkidle2",
            timeout: 0,
        });
        const result = await page.evaluate(s => eval(s), snippet);
        const formattedResult = this.maybeSerialize(result);
        return formattedResult;
    }
    maybeSerialize(result) {
        if (this.opts.json)
            return JSON.stringify(result, undefined, '\t');
        if (util_1.isArray(result))
            return result.join('\n');
        return result;
    }
}
exports.default = HeadlessEval;
//# sourceMappingURL=lib.js.map